include std/io.e
include std/dll.e
include std/error.e -- Crash routine

---<>--------------------------------------------
-- debugMsg
-------------------------------------------------
public procedure debugMsg(sequence message,sequence args) 
ifdef DEBUG then
	printf(1,sprintf("%s",{message}),args)
end ifdef
end procedure


---<>--------------------------------------------
-- Standard Open Dll function
-------------------------------------------------
public function OpenDLL(sequence name)
atom dll = open_dll(sprintf("%s",{name}))
	if (dll = 0) then
		crash("Did not find %s, exiting...\n",{name})
end if
	return dll
end function

---<>--------------------------------------------
-- Standard Wrap Calls
-------------------------------------------------
public function DefineFuncProc(atom lib, sequence args)
integer count = length(args)
sequence out = repeat(1,count)

for ii = 1 to count do
	integer inRow = length(args[ii])
	if inRow < 2 then
		out[ii] = -1
		crash("Wrong amount of arguments for C Func!\n")
	else
		
		if inRow = 2 then
			out[ii] = define_c_proc(lib,args[ii][1],args[ii][2])
		else 
			out[ii] = define_c_func(lib,args[ii][1],args[ii][2],args[ii][3])
		end if
		
		if out[ii] < 0 then
			crash("%s did not link \n",{args[ii][1]})
		end if
			debugMsg("Linking %s with %d \n",{args[ii][1],out[ii]})
	end if
end for
return out
end function


